'''
'''

import json
from os import (
    environ as env
)
from os import path
from os import listdir as ls
import setuptools
import yaml


def get_namespace(root: str, fpath: str = '', namespace: str = '') -> str:
    '''
    '''
    work_root = path.join(root, fpath)
    if '__init__.py' in ls(work_root):
        return namespace

    dirs = [d for d in ls(work_root) if path.isdir(path.join(work_root, d))]

    assert len(dirs) <= 1, 'Namespace generator require single-branch foldrs hierarhy.'

    namespace += '.' + dirs[0]
    fpath = path.join(fpath, dirs[0])

    return get_namespace(root, fpath, namespace)

with open('./env.json', 'r', encoding='utf-8') as conf_file:
    conf = json.load(conf_file)

with open('./env.yml', 'r', encoding='utf-8') as vars_file:
    include_vars = yaml.safe_load(vars_file)

root = conf['ROOT_NAME']

NAMESPACE = f"{root}{get_namespace(path.join('./src', root))}"
VERSION_MAJ = include_vars['VERSION']
AUTHOR = conf['AUTHOR']
EMAIL = conf['EMAIL']
DESCR = include_vars['DESCR']
URL = conf['URL']
REQUIREMENTS = [

]

with open('README.md', 'r', encoding='utf-8') as md:
    long_description = md.read()

setuptools.setup(
    name=f'{NAMESPACE.replace(".", "-")}',
    version=f'{VERSION_MAJ}{env.get("BUILD_SUFIX", ".")}{env.get("CI_PIPELINE_IID", "0")}',
    author=AUTHOR,
    author_email=EMAIL,
    description=DESCR,
    long_description=long_description,
    long_description_content_type="text/markdown",
    url=URL,
    package_dir={"": "src"},
    packages=[NAMESPACE],
    namespace_modules=[NAMESPACE],
    python_requires='>=3.9',
    install_requires=REQUIREMENTS
)
